var $support = {
	transform3d : ('WebKitCSSMatrix' in window),
	touch : ('ontouchstart' in window)
};

var $E = {
	start : $support.touch ? 'touchstart' : 'mousedown',
	move : $support.touch ? 'touchmove' : 'mousemove',
	end : $support.touch ? 'touchend' : 'mouseup'
};

function getTranslateX(x) {
	return $support.transform3d
			? 'translate3d(' + x + 'px, 0, 0)'
			: 'translate(' + x + 'px, 0)';
}
function getTranslateY(y) {
	return $support.transform3d
			? 'translate3d(0,' + y + 'px, 0)'
			: 'translate(0,' + y + 'px)';
}
function getPage(event, page) {
	return $support.touch ? event.changedTouches[0][page] : event[page];
}
var t1 ='';
var t2 ='';
var t3 ='';
var t4 ='';
var zyFlip2 = function(selector, dir, endFun,eClick) {
	var self = this;
	self.endFun = endFun || {};
	self.eClick = eClick || {};
	self.flag = true;
	self.nodes = [];
	// V:vertical
	// H:horizontal
	clearTimeout(self.timer);
	clearTimeout(t4);
	clearTimeout(t3);
	clearTimeout(t2);
	clearTimeout(t1);
	self.dir = dir || "H";
	if (selector.nodeType && selector.nodeType == 1) {
		self.element = selector;
	} else if (typeof selector == 'string') {
		self.id = selector;
		self.element = document.getElementById(selector)
				|| document.querySelector(selector);
	}

	// self.element.style.display = '-webkit-box';
	if(self.element.childElementCount==1)
	return;
	self.element.innerHTML += self.element.innerHTML;
	self.element.style.webkitTransitionProperty = '-webkit-transform';
	self.element.style.webkitTransitionTimingFunction = 'cubic-bezier(0,0,0.25,1)';
	self.element.style.webkitTransitionDuration = '0';

	if (self.dir == "H")
		self.element.style.webkitTransform = getTranslateX(0);
	else
		self.element.style.webkitTransform = getTranslateY(0);

	self.conf = {};
	self.touchEnabled = true;
	self.currentPoint = 0;
	self.currentXY = 0;

	self.refresh();
	//self.toNext();
	//
	self.element.parentNode.addEventListener($E.start, self, false);
	self.element.parentNode.addEventListener($E.move, self, false);
	document.addEventListener($E.end, self, false);

	return self;
}

zyFlip2.prototype = {
	handleEvent : function(event) {
		var self = this;

		switch (event.type) {
			case $E.start :
				self._touchStart(event);
				break;
			case $E.move :
				self._touchMove(event);
				break;
			case $E.end :
				self._touchEnd(event);
				break;
			case 'click' :
				self._click(event);
				break;
		}
	},
	refresh : function() {
		var self = this;

		var conf = self.conf;

		// setting max point
		self.maxPoint = conf.point || (function() {
			var childNodes = self.element.childNodes, itemLength = 0, i = 0, len = childNodes.length, node;
			for (; i < len; i++) {
				node = childNodes[i];
				if (node.nodeType === 1) {
					self.nodes[itemLength] = node;
					itemLength++;
				}
			}
			if (itemLength > 0) {
				itemLength--;
			}

			return itemLength;
		})();
		self.maxPoint += 1;
		// setting distance
		if (self.dir == "H")
			self.distance = conf.distance || self.element.scrollWidth
					/ (self.maxPoint);
		else
			self.distance = conf.distance || self.element.scrollHeight
					/ (self.maxPoint);
		// setting maxX maxY
		self.maxXY = conf.maxXY ? -conf.maxXY : -self.distance * self.maxPoint;

		self.moveToPoint(self.currentPoint);
	},
	dynturn : function() {
		var self = this;
		var timegap = 1000;
		// setTimeout(function(){self.moveToPoint()},);

	},
	hasNext : function() {
		var self = this;

		return self.currentPoint < self.maxPoint;
	},
	hasPrev : function() {
		var self = this;

		return self.currentPoint > 0;
	},
	toNext : function() {
		var self = this;

		if (!self.hasNext()) {
			return;
		}
		if (self.flag){
			if(self.currentPoint>=self.maxPoint/2){
				self.currentPoint = 0;
				
				self.element.style.webkitTransitionTimingFunction = 'cubic-bezier(0,0,0,1)';
				self.element.style.webkitTransitionDuration = '0';
				self._setXY(0);
				//self.toNext();
			//	t1=setTimeout(function() {
		//				self.toNext();
		//			}, 4000);
			}
			else{
				self.moveToPoint(self.currentPoint + 1);
		//		t2=setTimeout(function() {
		//				self.toNext();
		//			}, 4000);
				
			}
		}
	},
	toPrev : function() {
		var self = this;

		if (!self.hasPrev()) {
			return;
		}

		self.moveToPoint(self.currentPoint - 1);
	},
	moveToPoint : function(point) {
		var self = this;

		self.currentPoint = (point < 0) ? 0 : (point >= self.maxPoint/2)
				? self.maxPoint/2
				: parseInt(point);
		self.element.style.webkitTransitionTimingFunction = 'cubic-bezier(0,0,0.25,1)';
		self.element.style.webkitTransitionDuration = '1000ms';
		self._setXY(-self.currentPoint * self.distance);
		/*if (point == self.maxPoint) {
			self.currentPoint = 0;
			// self.element.style.webkitTransitionDuration = '1000ms';
			// self.element.style.webkitTransitionTimingFunction =
			// 'cubic-bezier(0,0,1,1)';
			self.element.style.webkitTransitionDuration = '0';
			self._setXY(0);
			self.endFun();
			// self.toNext();
		}*/
		if (self.endFun)
			t3=setTimeout(self.endFun, 10);

		/*
		 * var ev = document.createEvent('Event');
		 * ev.initEvent('css3flip.moveend', true, false);
		 * self.element.dispatchEvent(ev);
		 */

	},
	_setXY : function(xy) {
		var self = this;

		self.currentXY = xy;
		if (self.dir == "H")
			self.element.style.webkitTransform = getTranslateX(xy);
		else
			self.element.style.webkitTransform = getTranslateY(xy);
	},
	_touchStart : function(event) {
		var self = this;
		if(self.timer)
			clearTimeout(self.timer);
		self.flag = false;

		if (!self.touchEnabled) {
			return;
		}

		if (!$support.touch) {
			event.preventDefault();
		}

		self.element.style.webkitTransitionDuration = '0';
		self.scrolling = true;
		self.moveReady = false;
		self.startPageX = getPage(event, 'pageX');
		self.startPageY = getPage(event, 'pageY');
		if (self.dir == "H")
			self.basePage = self.startPageX;
		else
			self.basePage = self.startPageY
		self.direction = 0;
		self.startTime = event.timeStamp;
	},
	_touchMove : function(event) {
		var self = this;

		if (!self.scrolling) {
			return;
		}

		var pageX = getPage(event, 'pageX'), pageY = getPage(event, 'pageY'), distXY, newXY, deltaX, deltaY;

		if (self.moveReady) {
			// event.preventDefault();
			// event.stopPropagation();
			if (self.dir == "H")
				distXY = pageX - self.basePage;
			else
				distXY = pageY - self.basePage;
			newXY = self.currentXY + distXY;
			if (newXY >= 0 || newXY < self.maxXY) {
				newXY = Math.round(self.currentXY + distXY / 3);
			}
			self._setXY(newXY);

			self.direction = distXY > 0 ? -1 : 1;
		} else {
			deltaX = Math.abs(pageX - self.startPageX);
			deltaY = Math.abs(pageY - self.startPageY);
			if (self.dir == "H") {
				if (deltaX > deltaY && deltaX > 5) {
					// event.preventDefault();
					// event.stopPropagation();
					self.moveReady = true;
					self.element.parentNode.addEventListener('click', self, true);
				} else if (deltaY > 5) {
					self.scrolling = false;
				}
			} else {
				if (deltaY > deltaX && deltaY > 5) {
					// event.preventDefault();
					// event.stopPropagation();
					self.moveReady = true;
					self.element.parentNode.addEventListener('click', self, true);
				} else if (deltaX > 5) {
					self.scrolling = false;
				}
			}
		}
		if (self.dir == "H")
			self.basePage = pageX;
		else
			self.basePage = pageY;

	},
	_touchEnd : function(event) {
		var self = this;

		
		if (!self.scrolling) {
			return;
		}

		self.scrolling = false;

		var newPoint = -self.currentXY / self.distance;
		newPoint = (self.direction > 0)
				? Math.ceil(newPoint)
				: (self.direction < 0) ? Math.floor(newPoint) : Math
						.round(newPoint);

		self.moveToPoint(newPoint);
		
		if(self.currentPoint == self.maxPoint/2){
			self.currentPoint = 0;
			self.element.style.webkitTransitionDuration = '10ms';
			self._setXY(0);
		}
		else if(self.currentPoint == 0){
			self.currentPoint = self.maxPoint/2;
			self.element.style.webkitTransitionDuration = '10ms';
			self._setXY(-(self.maxPoint/2)*self.distance);
			//setTimeout(function(){self._setXY(0);},10);
		}
	//	self.timer = setTimeout(function(){self.flag = true;self.toNext();},3000);
	//	t4=setTimeout(function() {
	//				self.element.parentNode.removeEventListener('click', self, true);
	//			}, 200);
		var pageX = getPage(event, 'pageX');
		var pageY = getPage(event, 'pageY');
		/*if(self.eClick)
		{
			if(Math.abs(self.startPageX-pageX)<10 && Math.abs(self.startPageY-pageY)<10 && (event.timeStamp-self.startTime)<500)
			{
				self.eClick(self);
			}
		}*/
		
		// setTimeout(self.endFun, 500);
	},
	starttimer : function(m){
		var self = this;
	},
	_click : function(event) {
		var self = this;

		event.stopPropagation();
		event.preventDefault();
	},
	destroy : function() {
		var self = this;

		self.element.parentNode.removeEventListener(touchStartEvent, self);
		self.element.parentNode.removeEventListener(touchMoveEvent, self);
		document.removeEventListener(touchEndEvent, self);
	}
}
